<?php

//　モジュールインストール用スクリプト html直下に置いて動かす

// {{{ requires
require_once './require.php';
require_once(CLASS_REALDIR . "pages/LC_Page.php");


class LC_Page_Mdl_Dchk_Install extends LC_Page
{
    var $error = array(
            "permission"=>""
            );
    
    function init()
    {
        $this->arrfilepath = array(
            "payment.php" => HTML_REALDIR."/shopping/payment.php",
            "edit.php" => HTML_REALDIR.ADMIN_DIR."/order/edit.php",
            "templates/copy/subnavi.tpl" => DATA_REALDIR."Smarty/templates/admin/system/subnavi.tpl",
        );
        $this->arrCols = array(
            array("dtb_order", "dchk_status", "text"),
            array("dtb_customer", "regist_card", "smallint"),
            array("dtb_payment", "module_code", "text"),
        );
    }
    
    function process(){
        
        switch($_POST["mode"]){
            case "install":
                //ファイル上書き
                $this->copyFile();
                //SQL実行
                $this->addCol();
                $this->insertdata();
                
                if(strlen($this->error["permission"][0]) > 0){
                    $this->title="エラーが発生しました。";
                }else{
                    $_POST["mode"] = "";
                    $this->title="決済モジュールのインストールが完了しました";
                }
                break;
            default:
                $this->title="決済モジュールのインストールを開始します。";
                foreach($this->arrfilepath as $path){
                    if(!is_writeable($path)){
                        $this->error["permission"][] = $path."はサーバが書き込む事が出来ません。一時的に書き込み権限を付与してください。";
                    }
                }
                if(!is_writeable(HTML_REALDIR."dchkif.php")){
                    $this->error["permission"][] = HTML_REALDIR."にファイルを作成できません。一時的に書き込み権限を付与してください。";
                }

                break;
        }
        
    }
    
    function copyFile(){
        foreach($this->arrfilepath as $key=>$path){
            if(is_writeable($path)){
                copy(MODULE_REALDIR . 'mdl_dchk/'.$key,$path);
            }else{
                $this->error["permission"][] = $path."はサーバが書き込む事が出来ません。一時的に書き込み権限を付与してください。"; 
            }
        }
        if(!copy(MODULE_REALDIR . 'mdl_dchk/dchkif.php',HTML_REALDIR."dchkif.php")){
            $this->error["permission"][] = HTML_REALDIR."にファイルを作成できません。一時的に書き込み権限を付与してください。";
        }
    }

    function addCol(){
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        foreach($this->arrCols as $item) {
            $cols = $objQuery->listTableFields($item[0]);
            if(!in_array($item[1], $cols)) {
                $objQuery->exec("ALTER TABLE {$item[0]} ADD {$item[1]} {$item[2]}");
            }
        }
    }

    function insertdata(){
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        if($objQuery->count("dtb_module", "module_id = ?", array(6000)) == 0) {
            $objQuery->exec("INSERT INTO dtb_module VALUES (6000, 'mdl_dchk', 'ペイデザイン決済モジュール', '', 0, 0, NOW() , NOW() );");
        }
    }
    
    function destroy(){
    
    }
    
}

// }}}
// {{{ generate page

$objPage = new LC_Page_Mdl_Dchk_Install();
$objPage->init();
$objPage->process();
register_shutdown_function(array($objPage, "destroy"));
?>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <meta http-equiv="content-script-type" content="text/javascript" />
        <meta http-equiv="content-style-type" content="text/css" />
        <meta name="robots" content="noindex,nofollow" />
        <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.6.1/jquery.min.js"></script>
        <title>ペイデザイン決済モジュールインストール</title>
        <style type="text/css">
            body{margin:0;padding:0;height:100%;width:100%;text-align: center;background: #CCC;}
            div#main{text-align: left;font-size: 14px;line-height: 1.4em;color: #333;padding:20px 40px;border:1px solid #666;width:440px;background: url(http://www.paydesign.co.jp/img/dc/bg_header.gif) top left no-repeat #FFF;margin:20px auto;}
            div#main h1{
                color: #333333;
                font-size: 144%;
                height: 45px;
                padding: 5px 0;
                padding-top: 75px;
                margin:0;
            }
            input[type=submit]{
                border:1px solid #666;
                padding: 5px 16px;
                margin: 10px auto;
                background: #999;
                color: #FFF;
                text-shadow: -1px -1px 0 #333;
                font-size: 120%;
                font-weight: bold;
                cursor: pointer;
                border-radius: 5px;
                -moz-border-radius: 5px;
                -webkit-border-radius: 5px;
            }
            input[type=submit]:hover{background: #CCC;text-shadow: -1px -1px 0 #666;}
        </style>
<?php if(strlen($objPage->error["permission"][0]) > 0){ ?>

        <script type="text/javascript">
            $("input").hide();
        </script>
<?php } ?>
    </head>
    <body>
        <div id="main">
            <h1><?php echo $objPage->title;?></h1>
            <div>
                <?php if($_POST["mode"] == "install"){ ?>
                <p>モジュールのインストールが完了しました。</p>
                <p>管理画面のシステム管理より<a href="<?php echo HTTPS_URL . ADMIN_DIR ."load_module_config.php?module_id=6000"?>">モジュールの設定</a>を行ってくだいさい。</p>                    
                <?php }else{ ?>
                    <p>ペイデザイン決済モジュールをインストールします。</p>
                    <p>この決済モジュールは下記ファイルを上書きしますので、カスタマイズされている方はご注意ください。</p>
                    <?php foreach($objPage->error["permission"] as $erro){ ?>
                        <p style="color:red;"><?php echo $error;?></p>
                    <?php } ?>
                    <ul>
                        <?php foreach($objPage->arrfilepath as $val){ ?>
                        <li><?php echo realpath($val);?></li>
                        <?php } ?>
                    </ul>
                <?php } ?>
                <form action="?" method="post">
                    <input type="hidden" name="mode" value="install" />
                    <p style="text-align:center;"><input type="submit" value="インストール" /></p>
                </form>
            </div>
        </div>
    </body>
</html>